REBOL [
	Title: "Matlab Extension Test"
	author: "Jocko"
	date: 2-Nov-2009
	comment: {
	test and demo of the use of MatlabExt.dll
	}
]

secure [extension allow]

import %MatlabExt.dll

print " "
help Matlab

current-dir: to-string to-local-file what-dir

; start the matlab engine
Matlab-Start

; is it necessary to change the current matlab directory ? ...
; yes, in case of batch file execution
Matlab rejoin ["cd " current-dir]

; change the display format in the Matlab console, redirected to Rebol
; use a "compact" display format to avoid blank lines
Matlab {format compact; format long}
print Matlab "a = factorial(20)"

; execution of several instructions

Matlab {x=1:500; plot(x,sin(0.1*x)); title 'sin(0.1*x)'}
Matlab {figure; surfc(peaks(20)); title 'surfc(peaks(20))'}

; execution of a batch file : myTestFile.m
; Matlab { myTestFile }

ask "quit ?"

; when leaving the session
; close the matlab engine
Matlab-Stop
